Name:           owncloud
Version:        6.0.1
Release:        2%{?dist}
Summary:        Private file sync and share server

License:        AGPLv3+ and MIT and BSD and CC-BY and CC-BY-SA and GPLv3 and Public Domain and (MPLv1.1 or GPLv2+ or LGPLv2+) and (MIT or GPL+) and (MIT or GPLv2) and ASL 2.0 and LGPLv3
URL:            http://owncloud.org
# removed any occurences of jslint, see script delete-jslint
Source0:        %{name}-%{version}-repack.tar.bz2
# orig source:  http://owncloud.org/releases/%%{name}-%%{version}.tar.bz2
Source1:        %{name}-httpd.conf
Source6:        %{name}-nginx.conf
# packaging notes and doc
Source3:        %{name}-README.fedora
Source4:        %{name}-mysql.txt
Source5:        %{name}-postgresql.txt

# used to repack the source tarball
Source42:       %{name}-delete-jslint.sh

# adjust default config
Patch0:         %{name}-6.0.0-config.patch
# Adjust mediaelement not to use its SWF and Silverlight plugins. This
# changes 'plugins:["flash,"silverlight","youtube","vimeo"]' to
# 'plugins:["youtube","vimeo"]'
Patch1:         %{name}-4.5.13-videoviewer_noplugins.patch

# Merged upstream: https://github.com/owncloud/core/pull/6601
# https://github.com/owncloud/core/commit/9b4a827e0bd9dc02fe7f2c9487fed21f50447ea0
Patch10:        %{name}-6.0.0-pimple-include.patch
# Upstream submission https://github.com/owncloud/core/pull/6628
# achieves this in a somewhat different way
Patch11:        %{name}-6.0.0-fix-autoloader.patch
# Submitted upstream: https://github.com/owncloud/core/pull/6618
# Makes several points where apps load 3rdparty includes better for
# unbundling, replaces older separate patches for this purpose
# Stripped version, we'll do the line ending correction in %prep and
# we don't need to move Blowfish around as we unbundle it
Patch12:        %{name}-6.0.0a-apps_3rdparty_includes.patch
# This 'warning' gets triggered regularly on OC installs where CalDAV
# is used, see https://github.com/owncloud/contacts/issues/299 .
# Upstream is coming up with something, but in the meantime, make it
# a debug message instead.
Patch13:        %{name}-6.0.0a-sharing_backend_log.patch
# From upstream master:
# https://github.com/owncloud/core/commit/301d469813763cc28d82986f906eb29a45102294
Patch14:        %{name}-6.0.0a-fix-routing-symfony-2.3.patch


BuildArch:      noarch

# expand pear macros on install
BuildRequires:  php-pear

Requires:       %{name}-webserver = %{version}-%{release}
Requires:       %{name}-database = %{version}-%{release}


# PHP libs
Requires:       php-gd php-curl php-dom php-exif php-fileinfo php-gmp php-iconv
Requires:       php-json php-ldap php-mbstring php-openssl php-pcre php-pdo
Requires:       php-session php-simplexml php-spl php-zip php-ZendFramework-Pdf
Requires:       php-ZendFramework-Search-Lucene php-getid3 php-PHPMailer
Requires:       php-phpass php-Pimple
Requires:       php-irodsphp
%if 0%{?fedora} || 0%{?rhel} > 6
Requires:       php-filter
%endif
# PHP PEAR dependencies
# Upstream switched from Blowfish to AES in 5.0.7:
# http://blog.schiessle.org/2013/05/28/introduction-to-the-new-owncloud-encryption-app/
# This is now only used when decrypting files encrypted with older
# versions.
Requires:       php-pear(Crypt_Blowfish)
Requires:       php-pear(pear.dropbox-php.com/Dropbox)
Requires:       php-pear(Net_Curl) php-pear(XML_Parser) php-pear(pear.symfony.com/Routing)
Requires:       php-pear(pear.doctrine-project.org/DoctrineDBAL)
# SabreDAV
Requires:       php-pear(Sabre_CalDAV) >= 1.7.8 php-pear(Sabre_CardDAV) >= 1.7.8
Requires:       php-pear(phpseclib.sourceforge.net/Net_SFTP)

%if 0%{?rhel}
Requires(post): policycoreutils-python
Requires(postun): policycoreutils-python
%endif

%description
ownCloud gives you universal access to your files through a web interface or
WebDAV. It also provides a platform to easily view & sync your contacts,
calendars and bookmarks across all your devices and enables basic editing right
on the web. ownCloud is extendable via a simple but powerful API for
applications and plugins.


%package httpd
Summary:    Httpd integration for ownCloud

Provides:   %{name}-webserver = %{version}-%{release}
Requires:   %{name} = %{version}-%{release}

# PHP dependencies
Requires:       php

%description httpd
%{summary}


%package nginx
Summary:    Nginx integration for ownCloud

Provides:   %{name}-webserver = %{version}-%{release}
Requires:   %{name} = %{version}-%{release}

# PHP dependencies
Requires:   php-fpm nginx

%description nginx
%{summary}


%package mysql
Summary:    Virtual package providing MySQL dependencies for %{name}

Provides:   %{name}-database = %{version}-%{release}
Requires:   %{name} = %{version}-%{release}

Requires:   php-mysql
Requires:   mysql-server

%description mysql
%{summary}


%package postgresql
Summary:    Virtual package providing PostgreSQL dependencies for %{name}

Provides:   %{name}-database = %{version}-%{release}
Requires:   %{name} = %{version}-%{release}

Requires:   php-pgsql
Requires:   postgresql-server

%description postgresql
%{summary}


%package sqlite
Summary:    Virtual package providing Sqlite3 dependencies for %{name}

Provides:   %{name}-database = %{version}-%{release}
Requires:   %{name} = %{version}-%{release}
Requires:   php-sqlite3 php-pcre

%description sqlite
%{summary}


%prep
%setup -q -n %{name}
# Fix line endings of a file we're about to patch
sed -i 's/\r$//' apps/files_encryption/lib/crypt.php
%patch0
%patch1 -p1
%patch10
%patch11
%patch12 -p1
%patch13 -p1
%patch14

# prepare package doc
cp %{SOURCE3} README.fedora
cp %{SOURCE4} README.mysql
cp %{SOURCE5} README.postgresql


# Strip bundled libraries from global 3rdparty dir
rm -r 3rdparty/{Archive,Console,OS,getid3,phpass,PEAR,symfony,Sabre,Pimple,doctrine,XML}
rm 3rdparty/{System,class.phpmailer,class.smtp,MDB2,PEAR5}.php 3rdparty/PEAR-LICENSE

# FIXME package
# Used to generate previews and thumbnails for docx files if LibreOffice
# or OpenOffice is not available, see lib/private/preview/office-fallback.php
rm -r 3rdparty/phpdocx
# Used to generate previews and thumbnails for xls files if LibreOffice
# or OpenOffice is not available, see lib/private/preview/office-fallback.php
rm -r 3rdparty/PHPExcel
# Was added along with PHPExcel, I believe PHPExcel is the only thing that
# uses it. Note that phpdocx actually contains an entire other copy of dompdf...
rm -r 3rdparty/dompdf

# individual core apps now bundle libs as well - yay
rm -r apps/files_encryption/3rdparty/Crypt_Blowfish
rm -r apps/search_lucene/3rdparty/Zend
rm -r apps/files_external/3rdparty/{Dropbox,irodsphp,phpseclib}

# bundling notes:
## smb4php - forked php class from http://www.phpclasses.org/package/4129-PHP-Stream-wrapper-to-access-Windows-shared-files.html

## mediawiki contains two files picked from the mediawiki distribution
# Fedora packages mediawiki and we could theoretically re-use these,
# but it would require a dependency on the entirety of mediawiki,
# which is huge.
# the two files are for doing CSS and javascript minification.
# Alternatives are available, e.g. jshrink, and upstream is proposing
# to kill their run-time minification:
# https://github.com/owncloud/core/issues/4469

## php patchwork - https://github.com/nicolas-grekas/Patchwork-UTF8
# Used to set a UTF-8 locale (function isSetLocaleWorking does not
# just test whether setlocale works, it actually asks Patchwork to
# set a locale)  and its pure PHP implementation of the Normalizer
# class otherwise found in php-intl. See lib/private/util.php
# Patch from adamw to use php-intl's if available:
# https://github.com/owncloud/core/pull/6620
# We'd also have to set a UTF-8 locale some other way to entirely
# replace OC's use of Patchwork.

## php-opencloud - https://github.com/rackspace/php-opencloud
## php-seclib - http://phpseclib.sourceforge.net/
# Used for the 'external files' app's SFTP option, only uses the
# NET_SFTP package
# Review requests: https://bugzilla.redhat.com/show_bug.cgi?id=1047596
# and dependent tickets

## google-api-php-client - http://code.google.com/p/google-api-php-client
# Review request: https://bugzilla.redhat.com/show_bug.cgi?id=1047626


# clean up content
rm -r apps/{files_videoviewer/mediaelement,documents}/src
for f in {l10n.pl,init.sh,setup_owncloud.sh,image-optimization.sh,install_dependencies.sh}; do
    find . -name "$f" -exec rm {} \;
done
find . -size 0 -exec rm {} \;

# Drop pre-compiled binary lumps: Flash and Silverlight
# This means that Flash/Silverlight video/audio fallbacks in the
# 'media' and 'videoviewer' apps are not available.
# To re-introduce these they would have to be built from the
# source as part of this package build, they cannot be shipped
# pre-compiled. - AdamW, 2013/08
# https://fedoraproject.org/wiki/Packaging:Guidelines#No_inclusion_of_pre-built_binaries_or_libraries
rm apps/files_videoviewer/js/flashmediaelement.swf
rm apps/files_videoviewer/js/silverlightmediaelement.xap


%build
# Nothing to build


%install
install -dm 755 %{buildroot}%{_datadir}/%{name}

# create owncloud datadir
mkdir -p %{buildroot}%{_localstatedir}/lib/%{name}/data
# create writable app dir for appstore
mkdir -p %{buildroot}%{_localstatedir}/lib/%{name}/apps
# create owncloud sysconfdir
mkdir -p %{buildroot}%{_sysconfdir}/%{name}

# install content
for d in $(find . -mindepth 1 -maxdepth 1 -type d | grep -v config); do
    cp -a "$d" %{buildroot}%{_datadir}/%{name}
done

for f in {*.php,*.xml,*.html,occ,robots.txt}; do
    install -pm 644 "$f" %{buildroot}%{_datadir}/%{name} 
done

# set default config
install -pm 644 config/config.sample.php    %{buildroot}%{_sysconfdir}/%{name}/config.php

# symlink config dir
ln -s %{_sysconfdir}/%{name} %{buildroot}%{_datadir}/%{name}/config

# httpd config
install -Dpm 644 %{SOURCE1} \
    %{buildroot}%{_sysconfdir}/httpd/conf.d/%{name}.conf

# nginx config
install -Dpm 644 %{SOURCE6} \
    %{buildroot}%{_sysconfdir}/nginx/conf.d/%{name}.conf

# symlink 3rdparty libs - if possible
# global
ln -s %{_datadir}/php/PHPMailer/class.phpmailer.php    %{buildroot}%{_datadir}/%{name}/3rdparty/class.phpmailer.php
ln -s %{pear_phpdir}/Archive                           %{buildroot}%{_datadir}/%{name}/3rdparty/Archive
# individual
ln -s %{pear_phpdir}/Crypt %{buildroot}%{_datadir}/%{name}/apps/files_encryption/3rdparty/Crypt_Blowfish
ln -s %{_datadir}/php/Zend %{buildroot}%{_datadir}/%{name}/apps/search_lucene/3rdparty/Zend


%if 0%{?rhel}
%post
semanage fcontext -a -t httpd_sys_rw_content_t '%{_sysconfdir}/%{name}/config.php' 2>/dev/null || :
restorecon %{_sysconfdir}/%{name}/config.php || :

%postun
if [ $1 -eq 0 ] ; then
semanage fcontext -d -t httpd_sys_rw_content_t '%{_sysconfdir}/%{name}/config.php' 2>/dev/null || :
fi
%endif


%post httpd
%if 0%{?fedora} || 0%{?rhel} > 6
/usr/bin/systemctl reload httpd.service > /dev/null 2>&1 || :
%else
/sbin/service httpd reload > /dev/null 2>&1 || :
%endif

%postun httpd
if [ $1 -eq 0 ]; then
%if 0%{?fedora} || 0%{?rhel} > 6
  /usr/bin/systemctl reload httpd.service > /dev/null 2>&1 || :
%else
  /sbin/service httpd reload > /dev/null 2>&1 || :
%endif
fi

%post nginx
%if 0%{?fedora} || 0%{?rhel} > 6
  /usr/bin/systemctl reload nginx.service > /dev/null 2>&1 || :
  /usr/bin/systemctl reload php-fpm.service > /dev/null 2>&1 || :
%else
  /sbin/service nginx reload > /dev/null 2>&1 || :
  /sbin/service php-fpm reload > /dev/null 2>&1 || :
%endif

%postun nginx
if [ $1 -eq 0 ]; then
%if 0%{?fedora} || 0%{?rhel} > 6
  /usr/bin/systemctl reload nginx.service > /dev/null 2>&1 || :
  /usr/bin/systemctl reload php-fpm.service > /dev/null 2>&1 || :
%else
  /sbin/service nginx reload > /dev/null 2>&1 || :
  /sbin/service php-fpm reload > /dev/null 2>&1 || :
%endif
fi


%files
%doc AUTHORS COPYING-AGPL README.fedora config/config.sample.php

%dir %attr(-,apache,apache) %{_sysconfdir}/%{name}
# contains sensitive data (dbpassword, passwordsalt)
%config(noreplace) %attr(0600,apache,apache) %{_sysconfdir}/%{name}/config.php

%{_datadir}/%{name}
%dir %attr(0755,apache,apache) %{_localstatedir}/lib/%{name}
# user data must not be world readable
%dir %attr(0750,apache,apache) %{_localstatedir}/lib/%{name}/data
%attr(-,apache,apache) %{_localstatedir}/lib/%{name}/apps


%files httpd
%config(noreplace) %{_sysconfdir}/httpd/conf.d/%{name}.conf

%files nginx
%config(noreplace) %{_sysconfdir}/nginx/conf.d/%{name}.conf

%files mysql
%doc README.mysql
%files postgresql
%doc README.postgresql
%files sqlite


%changelog
* Mon Jan 27 2014 Adam Williamson <awilliam@redhat.com> - 6.0.1-2
- unbundle phpseclib (packaged now)

* Thu Jan 23 2014 Gregor Tätzner <brummbq@fedoraproject.org> - 6.0.1-1
- 6.0.1

* Tue Jan 14 2014 Gregor Tätzner <brummbq@fedoraproject.org>  - 6.0.0a-9
- fix routing with symfony 2.3

* Fri Jan 10 2014 Adam Williamson <awilliam@redhat.com> - 6.0.0a-8
- make a warning OC keeps triggering into a debug message

* Thu Jan  9 2014 Adam Williamson <awilliam@redhat.com> - 6.0.0a-7
- re-enable irods, patch loading of it, add dependency on it

* Fri Jan  3 2014 Adam Williamson <awilliam@redhat.com> - 6.0.0a-6
- disable irods a bit harder

* Fri Jan  3 2014 Adam Williamson <awilliam@redhat.com> - 6.0.0a-5
- drop non-existent OC_User_IMAP from config file

* Fri Jan  3 2014 Adam Williamson <awilliam@redhat.com> - 6.0.0a-4
- apps_3rdparty_includes: fix more 3rdparty loading stuff
- disable_irods: disable storage app's irods (it's broken)

* Mon Dec 30 2013 Adam Williamson <awilliam@redhat.com> - 6.0.0a-3
- tar-include, blowfish-include, dropbox-include: fix more paths

* Mon Dec 30 2013 Adam Williamson <awilliam@redhat.com> - 6.0.0a-2
- dropbox-include.patch: fix loading of system copy of php-Dropbox

* Sun Dec 22 2013 Adam Williamson <awilliam@redhat.com> - 6.0.0a-1
- 6.0.0a

* Sun Dec 22 2013 Gregor Tätzner <brummbq@fedoraproject.org> - 6.0.0-1
- 6.0.0

* Fri Dec 20 2013 Adam Williamson <awilliam@redhat.com> - 5.0.14a-2
- Correct location of php-symfony-routing: #1045301

* Fri Dec 20 2013 Adam Williamson <awilliam@redhat.com> - 5.0.14a-1
- 5.0.14a

* Sat Nov 16 2013 Gregor Tätzner <brummbq@fedoraproject.org> - 5.0.13-1
- 5.0.13

* Tue Oct 08 2013 Gregor Tätzner <brummbq@fedoraproject.org> - 5.0.12-1
- 5.0.12

* Tue Sep 24 2013 Gregor Tätzner <brummbq@fedoraproject.org> - 5.0.11-2
- keep MDB2/pgsql driver, genuine version causes upgrade problems (RBZ#962082)

* Sat Sep 07 2013 Gregor Tätzner <brummbq@fedoraproject.org> - 5.0.11-1
- 5.0.11

* Wed Sep 04 2013 Gregor Tätzner <brummbq@fedoraproject.org> - 5.0.10-4
- unbundle sabredav again

* Fri Aug 23 2013 Adam Williamson <awilliam@redhat.com> - 5.0.10-3
- patch mediaelement not to try and use its plugins

* Fri Aug 23 2013 Adam Williamson <awilliam@redhat.com> - 5.0.10-2
- drop binary Flash and Silverlight blobs: #1000257
- don't ship source of jplayer in the binary package

* Sun Aug 18 2013 Gregor Tätzner <brummbq@fedoraproject.org> - 5.0.10-1
- 5.0.10

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 5.0.9-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Tue Jul 23 2013 Gregor Tätzner <brummbq@fedoraproject.org> - 5.0.9-2
- buildreq: php-pear (RBZ #987279)

* Tue Jul 16 2013 Gregor Tätzner <brummbq@fedoraproject.org> - 5.0.9-1
- major upgrade to 5.0.9
- symlink 3rdparty libs and drop most of the patches
- new deps: php-ZendFramework symfony

* Sat Jun 08 2013 Gregor Tätzner <brummbq@fedoraproject.org> - 4.5.12-1
- 4.5.12

* Thu May 16 2013 Gregor Tätzner <brummbq@fedoraproject.org> - 4.5.11-2
- RBZ #963701: require mdb2-mysql not mysqli

* Thu May 16 2013 Gregor Tätzner <brummbq@fedoraproject.org> - 4.5.11-1
- 4.5.11

* Tue Apr 23 2013 Gregor Tätzner <brummbq@fedoraproject.org> - 4.5.10-1
- 4.5.10

* Sat Apr 13 2013 Gregor Tätzner <brummbq@fedoraproject.org> - 4.5.9-1
- 4.5.9
- disable remote access by default

* Fri Mar 15 2013 Gregor Tätzner <brummbq@fedoraproject.org> - 4.5.8-1
- 4.5.8
- unbundle dropbox-php
- log to syslog
- include nginx config

* Mon Feb 25 2013 Gregor Tätzner <brummbq@fedoraproject.org> - 4.5.7-2
- added script for re-creating stripped tarball
- new httpd.conf for httpd 2.4

* Sun Feb 24 2013 Gregor Tätzner <brummbq@fedoraproject.org> - 4.5.7-1
- 4.5.7

* Sun Jan 13 2013 Gregor Tätzner <brummbq@fedoraproject.org> - 4.0.8-7
- fixed selinux file context on rhel

* Sat Dec 08 2012 Gregor Tätzner <brummbq@fedoraproject.org> - 4.0.8-6
- unbundled phpass and php-when
- added database setup instructions

* Thu Nov 08 2012 Gregor Tätzner <brummbq@fedoraproject.org> - 4.0.8-5
- moved included sqlite3 driver to owncloud-sqlite
- unbundled php-cloudfiles
- reworked runtime requirements

* Sun Nov 04 2012 Gregor Tätzner <brummbq@fedoraproject.org> - 4.0.8-4
- repacked source tarball (deleted jslint code)

* Sat Nov 03 2012 Gregor Tätzner <brummbq@fedoraproject.org> - 4.0.8-3
- added missing licenses
- obliterated jslint code from aceeditor

* Fri Nov 02 2012 Gregor Tätzner <brummbq@fedoraproject.org> - 4.0.8-2
- updated license field
- added README.fedora

* Thu Oct 18 2012 Gregor Tätzner <brummbq@fedoraproject.org> - 4.0.8-1
- owncloud-4.0.8

* Fri Oct 12 2012 Gregor Tätzner <brummbq@fedoraproject.org> - 4.0.7-5
- unbundle php-getid3
- remove conf dir access check

* Tue Oct 02 2012 Gregor Tätzner <brummbq@fedoraproject.org> - 4.0.7-4
- require rsyslog
- switched log type back to 'owncloud'

* Sun Sep 23 2012 Gregor Tätzner <brummbq@fedoraproject.org> - 4.0.7-3
- unbundled Archive/Tar.php, Guess.php, phpmailer
- created virtual packages for supported databases
- added logrotate script

* Thu Sep 20 2012 Gregor Tätzner <brummbq@fedoraproject.org> - 4.0.7-2
- moved httpd files and sciptlets into own subpackage
- redirected log output to /var/log/owncloud.log
- deleted unecessary files

* Wed Sep 19 2012 Gregor Tätzner <brummbq@fedoraproject.org> - 4.0.7-1
- updated to version 4.0.7

* Fri Apr 06 2012 Felix Kaechele <heffer@fedoraproject.org> - 3.0.1-1
- initial package

